http://acm.hdu.edu.cn/showproblem.php?pid=3449
https://www.cnblogs.com/wangmengmeng/p/4840840.html
FJ is going to do some shopping, and before that, he needs some boxes to carry the different kinds of stuff he is going to buy. Each box is assigned to carry some specific kinds of stuff (that is to say, if he is going to buy one of these stuff, he has to buy the box beforehand). Each kind of stuff has its own value. Now FJ only has an amount of W dollars for shopping, he intends to get the highest value with the money.
Input
The first line will contain two integers, n (the number of boxes 1 <= n <= 50), w (the amount of money FJ has, 1 <= w <= 100000) Then n lines follow. Each line contains the following number pi (the price of the ith box 1<=pi<=1000), mi (1<=mi<=10 the number goods ith box can carry), and mi pairs of numbers, the price cj (1<=cj<=100), the value vj(1<=vj<=1000000)
Output
For each test case, output the maximum value FJ can get
Sample Input
3 800 300 2 30 50 25 80 600 1 50 130 400 3 40 70 30 40 35 60
Sample Output
210
题意:有n件物品,对应有不同的价格和价值,这是典型的01背包。但现在有了一个限制,要买物品先买能装这件物品的特定的盒子,盒子的价值为0
代码理解得还不是太好,感觉这是一个“二重”的01背包。首先假设先买第i个盒子,对每个盒子里的物品进行一次01背包;然后对盒子再进行一次01背包,决策到底要不要买这个盒子
dp[i][j]表示前i个盒子有j元钱能获得的最大价值,则所求就是dp[n][total]
因为物品对盒子有了“依赖”,所以要先对dp赋值为-1,表示买不到盒子就更不可能装物品
16 memset(dp,-1,sizeof(dp)); //有依赖关系,要赋初值-1 17 memset(dp[0],0,sizeof(dp[0])); 18 for(int i=1;i<=n;i++){ 19 int box,m; 20 scanf("%d%d",&box,&m); 21 for(int j=box;j<=total;j++) 22 dp[i][j]=dp[i-1][j-box];//先让i层买盒子,因为盒子没有价值, 23 //所以直接等于上一层的花费+盒子钱 24 for(int j=0;j<m;j++){//在已花费盒子钱的基础上,此时再对dp[i]层做01背包, 25 //即i层一个盒子多种物品的最大价值 26 int c,w; 27 scanf("%d%d",&c,&w); 28 for(int k=total;k>=c;k--){ 29 if(dp[i][k-c]!=-1)//注意依赖背包有不可能的情况,这里即k买不到盒子和这个物品, 30 //不能装物品 31 dp[i][k]=max(dp[i][k],dp[i][k-c]+w);// 这里不能dp[i][k]=max(dp[i][j],dp[i][k-box-c]+w) 32 //因为已经买过盒子了,这个表达式代表一个盒子基础上一个物品带一个盒子 33 } 34 } 35 for(int j=0;j<=total;j++)//决策是否买第i个盒子 36 dp[i][j]=max(dp[i][j],dp[i-1][j]);//不要忘了考虑不选当前组的情况(不是必选) 37 }
https://www.cnblogs.com/fzl194/p/8833098.html
所以先对每一个箱子进行01背包,保存可以凑出的所有的花费和该花费的最大价值,这是一组中的所有状态,且只能取一个或者不取,背包转化成分组背包,然后就可以做了。
9 const int maxn = 1e5 + 10; 10 int T, n, m, cases; 11 struct node 12 { 13 int price; 14 int num; 15 int price_sum; 16 int cost[11], value[11]; 17 int dp[1005]; 18 }; 19 node a[100]; 20 int dp[maxn]; 21 int main() 22 { 23 while(cin >> n >> m) 24 { 25 memset(dp, 0, sizeof(dp)); 26 memset(a, 0, sizeof(a)); 27 for(int i = 0; i < n; i++) 28 { 29 scanf("%d%d", &a[i].price, &a[i].num); 30 a[i].price_sum = 0; 31 for(int j = 0; j < a[i].num; j++) 32 { 33 scanf("%d%d", &a[i].cost[j], &a[i].value[j]); 34 a[i].price_sum += a[i].cost[j]; 35 } 36 } 37 for(int i = 0; i < n; i++)//对,每个箱子预处理出所有可凑出的花费和该花费的最大价值 38 { 39 memset(a[i].dp, -1, sizeof(a[i].dp)); 40 a[i].dp[0] = 0; 41 for(int j = 0; j < a[i].num; j++) 42 { 43 for(int k = a[i].price_sum; k >= a[i].cost[j]; k--) 44 if(a[i].dp[k - a[i].cost[j]] >= 0)a[i].dp[k] = max(a[i].dp[k], a[i].dp[k - a[i].cost[j]] + a[i].value[j]); 45 }/* 46 for(int j = 0; j <= a[i].price_sum; j++) 47 cout<<a[i].dp[j]<<" "; 48 cout<<endl;*/ 49 } 50 for(int i = 0; i < n; i++)//枚举每一个的箱子 51 { 52 vector<Pair>d; 53 for(int j = 0; j <= a[i].price_sum; j++)//将该箱子的所有状态存下来 54 { 55 if(a[i].dp[j] > 0) 56 d.push_back(Pair(j + a[i].price, a[i].dp[j])); 57 } 58 for(int v = m; v >= 0; v--)//枚举花费 59 { 60 for(int j = 0; j < d.size(); j++)//枚举改组的状态 61 if(v >= d[j].first) 62 dp[v] = max(dp[v], dp[v - d[j].first] + d[j].second); 63 } 64 } 65 cout<<dp[m]<<endl; 66 }
还有一种写法,在dp的时候把预处理和状态转化合并起来,时间复杂度降低了一点
10 int T, n, m, cases; 11 int a[105]; 12 int dp[55][100005]; 13 struct node 14 { 15 int v, w; 16 }; 17 vector<node>G[105]; 18 int main() 19 { 20 while(cin >> n >> m) 21 { 22 memset(dp, 0, sizeof(dp)); 23 for(int i = 1; i <= n; i++)G[i].clear(); 24 int tot, x, y; 25 for(int i = 1; i <= n; i++) 26 { 27 scanf("%d%d", &a[i], &tot); 28 for(int j = 0; j < tot; j++) 29 { 30 scanf("%d%d", &x, &y); 31 G[i].push_back(node{x, y}); 32 } 33 } 34 35 for(int i = 1; i <= n; i++)//枚举每种箱子 36 { 37 for(int j = 0; j < a[i]; j++)dp[i][j] = -1; 38 for(int j = a[i]; j <= m; j++)dp[i][j] = dp[i - 1][j - a[i]];//这里是确保先购买购物车 39 40 for(int j = 0; j < G[i].size(); j++)//在购物车内进行01背包 41 { 42 for(int k = m; k >= G[i][j].v; k--) 43 { 44 if(dp[i][k - G[i][j].v] != -1) 45 dp[i][k] = max(dp[i][k], dp[i][k - G[i][j].v] + G[i][j].w); 46 } 47 } 48 for(int j = 0; j <= m; j++)dp[i][j] = max(dp[i - 1][j], dp[i][j]);//和之前的值比较 49 } 50 cout<<dp[n][m]<<endl; 51 }